<template>
  <rui-field v-bind="wrapperProps">
    <input v-model="date"
           v-bind="inputProps"
           :disabled="disabled"
           :required="required"
           @change="handleChange">
    <rui-button v-if="clearable"
                class="rui-field__field__append"
                icon="rui:x-bold"
                :title="$t('rui.input.clear')"
                @click="clearInput" />
  </rui-field>
</template>

<script>
import { dateToInputString } from '../../../lib/Dates'
import { randomString } from '../../../lib/String.js'
import RuiField from '../../Form/Field.vue'
import RuiButton from '../../Button/Button.vue'

/**
 * Wrapper for a date input, manipulating only `Date` objects.
 *
 * The control is wrapped in a `RuiField` component.
 *
 * @preset Default { "props": { "inputName": "the_date" } }
 *
 * @bindValue "2023/09/09 00:00"
 * @disableProps modelValue
 * @propsGroup Input               [disabled, required, inputName]
 * @propsGroup Constraints         [notBefore, notAfter]
 * @propsGroup Options             [time, clearable]
 * @propsGroup Input wrapper props [inputId, label, append, help, error, inline, invisibleLabel]
 */
export default {
  name: 'RuiDateTimePicker',
  emits: [
    /**
     * Fired when date changes.
     *
     * @param {Date} details - New date
     */
    'update:modelValue',
  ],
  components: { RuiButton, RuiField },
  props: {
    /** Used for `v-model` or specified when input has a one-way binding */
    modelValue: { required: false, type: [Date, String], default: null },

    // Input
    /** Whether to disable the input */
    disabled: { required: false, type: Boolean, default: false },
    /** Whether the input is required */
    required: { required: false, type: Boolean, default: false },
    /** Input "name" attribute */
    inputName: { required: true, type: String },

    // Constraints
    /** Date to limit the selection */
    notBefore: { required: false, type: Date, default: null },
    /** Date to limit the selection */
    notAfter: { required: false, type: Date, default: null },

    // Options
    /** Whether to display time picker */
    time: { required: false, type: Boolean, default: true },
    /** Whether to display a button to clear the input */
    clearable: { required: false, type: Boolean, default: true },

    // Props to forward to rui-input
    /** Input "id" attribute */
    inputId: { required: false, type: String, default: randomString() },
    /** Optional label for "label" HTML element */
    label: { required: false, type: String, default: null },
    /** Text to append next to the slot */
    append: { required: false, type: String, default: null },
    /** Optional help text */
    help: { required: false, type: String, default: null },
    /** Error text, if any */
    error: { required: false, type: [String, Array], default: null },
    /** Style the slot content for an inline display (i.e.: border radius,...) */
    inline: { required: false, type: Boolean, default: false },
    /** Whether to make the label visible for screen readers only */
    invisibleLabel: { required: false, type: Boolean, default: false },
  },
  data () {
    return {
      date: '',
    }
  },
  computed: {
    inputProps () {
      const props = {
        type: this.$props.time ? 'datetime-local' : 'date',
        id: this.$props.inputId,
        name: this.$props.inputName,
      }
      if (this.$props.notBefore) props.min = dateToInputString(this.$props.notBefore, this.$props.time)
      if (this.$props.notAfter) props.max = dateToInputString(this.$props.notAfter, this.$props.time)

      return props
    },
    wrapperProps () {
      return {
        inputId: this.inputId,
        label: this.label,
        append: this.append,
        help: this.help,
        error: this.error,
        inline: this.inline,
        invisibleLabel: this.invisibleLabel,
      }
    },
  },
  methods: {
    updateState () {
      this.date = dateToInputString(this.$props.modelValue, this.$props.time)
    },
    handleChange () {
      // Field was cleared: clear value
      if (this.date === '') {
        this.clearInput()
        return
      }

      // Invalid date: do nothing
      const newDate = new Date(this.date)
      if (!(newDate instanceof Date) || isNaN(newDate.valueOf())) return

      this.$emit('update:modelValue', newDate)
    },
    clearInput () {
      this.$emit('update:modelValue', null)
    },
  },
  created () {
    this.updateState()
  },
  watch: {
    modelValue (newValue, oldValue) {
      if (newValue === oldValue) return

      this.updateState()
    },
  },
}
</script>
